diff -ruN ccp4srs-old/ccp4srs/memio_.cpp ccp4srs/ccp4srs/memio_.cpp
--- ccp4srs-old/ccp4srs/memio_.cpp	2014-03-24 10:40:19.000000000 -0700
+++ ccp4srs/ccp4srs/memio_.cpp	2014-09-09 21:34:12.000000000 -0700
@@ -1,10 +1,10 @@
-//  $Id: memio_.h, v 1.00 2010/03/11 15:28:14 Eugene Exp $
+//  $Id: memio_.cpp $
 //  =================================================================
 //
 //   CCP4 SRS Library: Storage, Retrievak and Search support for
 //   CCP4 ligand data.
 //
-//   Copyright (C) Eugene Krissinel 2010.
+//   Copyright (C) Eugene Krissinel 2010-2013.
 //
 //   This library is free software: you can redistribute it and/or
 //   modify it under the terms of the GNU Lesser General Public
@@ -22,478 +22,479 @@
 //
 //  =================================================================
 //
-//    11.03.10   <--  Date of Last Modification.
+//    18.09.13   <--  Date of Last Modification.
 //                   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 //  -----------------------------------------------------------------
 //
-//  **** Module  :  memio_  <interface>
+//  **** Module  :  memio_  <implementation>
 //       ~~~~~~~~~
-//  **** Classes :  CMemIO  - buffered I/O
+//  **** Classes :  ccp4srs::MemIO  - buffered I/O
 //       ~~~~~~~~~
 //
-//  (C) E. Krissinel 2010
+//  (C) E. Krissinel 2010-2013
 //
 //  =================================================================
 //
 
 #include <string.h>
-
 #include <zlib.h>
 
 #include "memio_.h"
 
+namespace ccp4srs  {
 
-CMemIO::CMemIO()  {
+  MemIO::MemIO()  {
 
-  compression_level  = Z_NO_COMPRESSION;
-  compression_buffer = NULL;
-  compression_alloc  = 0;
+    compression_level  = Z_NO_COMPRESSION;
+    compression_buffer = NULL;
+    compression_alloc  = 0;
 
-  buffer        = NULL;
-  buffer_length = 0;
-  buffer_pos    = 0;
-  alloc_length  = 0;
-  chunk_size    = 10000;
+    buffer        = NULL;
+    buffer_length = 0;
+    buffer_pos    = 0;
+    alloc_length  = 0;
+    chunk_size    = 10000;
 
-}
+  }
 
-CMemIO::~CMemIO()  {
-  free();
-}
+  MemIO::~MemIO()  {
+    free();
+  }
 
-void CMemIO::setCompressionLevel ( int compressionLevel )  {
-  switch (compressionLevel)  {
-    case 0:  compression_level = Z_NO_COMPRESSION;      break;
-    case 1:  compression_level = Z_BEST_SPEED;          break;
-    case 2:  compression_level = Z_DEFAULT_COMPRESSION; break;
-    default: compression_level = Z_BEST_COMPRESSION;
+  void MemIO::setCompressionLevel ( int compressionLevel )  {
+    switch (compressionLevel)  {
+      case 0:  compression_level = Z_NO_COMPRESSION;      break;
+      case 1:  compression_level = Z_BEST_SPEED;          break;
+      case 2:  compression_level = Z_DEFAULT_COMPRESSION; break;
+      default: compression_level = Z_BEST_COMPRESSION;
+    }
   }
-}
 
 
-int CMemIO::read ( cpstr fileName, byte gzMode )  {
-CFile f;
-int   rc;
+  int MemIO::read ( mmdb::cpstr fileName, mmdb::io::GZ_MODE gzMode )  {
+  mmdb::io::File f;
+  int            rc;
 
-  buffer_pos = 0;
-  rc = CMemIO::Ok;
+    buffer_pos = 0;
+    rc = MemIO::Ok;
 
-  f.assign ( fileName,False,True,gzMode );
+    f.assign ( fileName,false,true,gzMode );
 
-  if (f.reset(True))  rc = read ( f );
-                else  rc = CMemIO::CantOpenFile;
+    if (f.reset(true))  rc = read ( f );
+                  else  rc = MemIO::CantOpenFile;
 
-  if (rc!=CMemIO::Ok)
-    free();
+    if (rc!=MemIO::Ok)
+      free();
 
-  f.shut();
+    f.shut();
 
-  return rc;
+    return rc;
 
-}
+  }
 
-int CMemIO::read ( RCFile f )  {
-int    rc,len;
-uLongf dsize;
+  int MemIO::read ( mmdb::io::RFile f )  {
+  int    rc,len;
+  uLongf dsize;
 
-  buffer_pos = 0;
+    buffer_pos = 0;
 
-  if (f.ReadInt(&buffer_length))  {
+    if (f.ReadInt(&buffer_length))  {
 
-    if (buffer_length==0)
-      rc = CMemIO::EmptyFile;
+      if (buffer_length==0)
+        rc = MemIO::EmptyFile;
 
-    else if (buffer_length>0)  { // no compression
+      else if (buffer_length>0)  { // no compression
+
+        if (buffer_length>alloc_length)  {
+          mmdb::FreeVectorMemory ( buffer,0 );
+          alloc_length = buffer_length;
+          mmdb::GetVectorMemory ( buffer,alloc_length,0 );
+        }
+        if (f.ReadFile(buffer,buffer_length))
+              rc = MemIO::Ok;
+        else  rc = MemIO::ReadError;
+
+      } else  { // decompress
+
+        buffer_length = -buffer_length - 1;
+        if (buffer_length>alloc_length)  {
+          mmdb::FreeVectorMemory ( buffer,0 );
+          alloc_length = buffer_length;
+          mmdb::GetVectorMemory ( buffer,alloc_length,0 );
+        }
+
+        if (f.ReadInt(&len))  {
+
+          if (compression_alloc<=len)  {
+            mmdb::FreeVectorMemory ( compression_buffer,0 );
+            compression_alloc = len + 100;
+            mmdb::GetVectorMemory  ( compression_buffer,compression_alloc,0 );
+          }
+
+          if (f.ReadFile(compression_buffer,len))  {
+            dsize = alloc_length;
+            rc = uncompress ( buffer,&dsize,compression_buffer,len );
+            if (rc==Z_OK)  {
+              if (int(dsize)!=buffer_length)  rc = MemIO::SizeError;
+                                        else  rc = MemIO::Ok;
+            } else
+              rc = MemIO::UncompressionError;
+          } else
+            rc = MemIO::ReadError;
+
+        } else
+          rc = MemIO::ReadError;
 
-      if (buffer_length>alloc_length)  {
-        FreeVectorMemory ( buffer,0 );
-        alloc_length = buffer_length;
-        GetVectorMemory ( buffer,alloc_length,0 );
       }
-      if (f.ReadFile(buffer,buffer_length))
-            rc = CMemIO::Ok;
-      else  rc = CMemIO::ReadError;
-
-    } else  { // decompress
-
-      buffer_length = -buffer_length - 1;
-      if (buffer_length>alloc_length)  {
-        FreeVectorMemory ( buffer,0 );
-        alloc_length = buffer_length;
-        GetVectorMemory ( buffer,alloc_length,0 );
+
+    } else
+      rc = MemIO::ReadError;
+
+    return rc;
+
+  }
+
+  int MemIO::write ( mmdb::cpstr fileName, mmdb::io::GZ_MODE gzMode )  {
+  mmdb::io::File f;
+  int            rc;
+
+    rc = MemIO::Ok;
+
+    f.assign ( fileName,false,true,gzMode );
+
+    if (f.rewrite()) rc = write(f);
+                else rc = MemIO::CantOpenFile;
+
+    f.shut();
+
+    return rc;
+
+  }
+
+  int MemIO::write ( mmdb::io::RFile f )  {
+  int    rc,len;
+  uLongf csize;
+
+    rc = MemIO::Ok;
+
+    if ((compression_level==Z_NO_COMPRESSION) || (buffer_length<=0))  {
+
+      if (f.WriteInt(&buffer_length))  {
+        if (!f.WriteFile(buffer,buffer_length))
+          rc = MemIO::WriteError;
       }
 
-      if (f.ReadInt(&len))  {
+    } else  {
+
+      len = -buffer_length - 1;
+      if (f.WriteInt(&len))  {
 
-        if (compression_alloc<=len)  {
-          FreeVectorMemory ( compression_buffer,0 );
-          compression_alloc = len + 100;
-          GetVectorMemory  ( compression_buffer,compression_alloc,0 );
+        csize = (uLongf)(1.1*buffer_length);
+        if (compression_alloc<=int(csize))  {
+          mmdb::FreeVectorMemory ( compression_buffer,0 );
+          mmdb::GetVectorMemory  ( compression_buffer,csize,0 );
         }
 
-        if (f.ReadFile(compression_buffer,len))  {
-          dsize = alloc_length;
-          rc = uncompress ( buffer,&dsize,compression_buffer,len );
-          if (rc==Z_OK)  {
-            if (int(dsize)!=buffer_length)  rc = CMemIO::SizeError;
-                                      else  rc = CMemIO::Ok;
+        rc = compress2 ( compression_buffer,&csize,
+                         buffer,buffer_length,compression_level );
+
+        if (rc==Z_OK)  {
+          len = csize;
+          if (f.WriteInt(&len))  {
+            if (!f.WriteFile(compression_buffer,csize))
+                  rc = MemIO::WriteError;
+            else  rc = MemIO::Ok;
           } else
-            rc = CMemIO::UncompressionError;
+            rc = MemIO::WriteError;
         } else
-          rc = CMemIO::ReadError;
+          rc = MemIO::CompressionError;
 
       } else
-        rc = CMemIO::ReadError;
+        rc = MemIO::WriteError;
+
+    }
+
+    return rc;
+
+  }
+
+  void MemIO::reset()  {
+    buffer_length = 0;
+  }
+
+  void MemIO::free()  {
+    mmdb::FreeVectorMemory ( compression_buffer,0 );
+    mmdb::FreeVectorMemory ( buffer            ,0 );
+    compression_alloc = 0;
+    buffer_length     = 0;
+    buffer_pos        = 0;
+    alloc_length      = 0;
+  }
+
+  void *MemIO::get_buffer ( const int length )  {
+    if (alloc_length<length)  {
+      mmdb::FreeVectorMemory ( buffer,0 );
+      alloc_length = length;
+      mmdb::GetVectorMemory ( buffer,alloc_length,0 );
+    }
+    return buffer;
+  }
+
+  void MemIO::get_buffer ( mmdb::pstr * buf, int * length )  {
+    *buf    = mmdb::pstr(buffer);
+    *length = buffer_length;
+  }
+
 
+  void MemIO::write_buffer ( const void * src, const int length  )  {
+  mmdb::bvector b1;
+    if (buffer_length+length>=alloc_length)  {
+      alloc_length += length+chunk_size;
+      mmdb::GetVectorMemory ( b1,alloc_length,0 );
+      memcpy ( b1,buffer,buffer_length );
+      mmdb::FreeVectorMemory ( buffer,0 );
+      buffer = b1;
     }
+    memcpy ( &(buffer[buffer_length]),src,length );
+    buffer_length += length;
+  }
 
-  } else
-    rc = CMemIO::ReadError;
 
-  return rc;
+  void MemIO::put_integer ( int I )  {
+  mmdb::intUniBin iUB;
+    mmdb::int2UniBin ( I,iUB );
+    write_buffer ( iUB,sizeof(mmdb::intUniBin) );
+  }
 
-}
+  void MemIO::put_ishort ( int I )  {
+  mmdb::shortUniBin sUB;
+    mmdb::short2UniBin ( short(I),sUB );
+    write_buffer ( sUB,sizeof(mmdb::shortUniBin) );
+  }
 
-int CMemIO::write ( cpstr fileName, byte gzMode )  {
-CFile f;
-int   rc;
+  void MemIO::put_ibyte ( int I )  {
+  // here we do not rely only on little-endian architectures
+  mmdb::byte B;
+    B = mmdb::byte(I);
+    write_buffer ( &B,sizeof(mmdb::byte) );
+  }
 
-  rc = CMemIO::Ok;
+  void MemIO::put_byte ( mmdb::byte B )  {
+    write_buffer ( &B,sizeof(mmdb::byte) );
+  }
 
-  f.assign ( fileName,False,True,gzMode );
+  void MemIO::put_short ( short I )  {
+  mmdb::shortUniBin sUB;
+    mmdb::short2UniBin ( I,sUB );
+    write_buffer ( sUB,sizeof(mmdb::shortUniBin) );
+  }
 
-  if (f.rewrite()) rc = write(f);
-              else rc = CMemIO::CantOpenFile;
+  void MemIO::put_long ( long I )  {
+  mmdb::longUniBin lUB;
+    mmdb::long2UniBin ( I,lUB );
+    write_buffer ( lUB,sizeof(mmdb::longUniBin) );
+  }
 
-  f.shut();
+  void MemIO::put_word ( mmdb::word W )  {
+  mmdb::wordUniBin wUB;
+    mmdb::word2UniBin ( W,wUB );
+    write_buffer ( wUB,sizeof(mmdb::wordUniBin) );
+  }
 
-  return rc;
+  void MemIO::put_real ( mmdb::realtype R )  {
+  mmdb::realUniBin rUB;
+    mmdb::real2UniBin ( R,rUB );
+    write_buffer ( rUB,sizeof(mmdb::realUniBin) );
+  }
 
-}
+  void MemIO::put_float ( mmdb::realtype R )  {
+  mmdb::floatUniBin fUB;
+    mmdb::float2UniBin ( R,fUB );
+    write_buffer ( fUB,sizeof(mmdb::floatUniBin) );
+  }
 
-int CMemIO::write ( RCFile f )  {
-int    rc,len;
-uLongf csize;
+  void MemIO::put_shortreal ( mmdb::shortreal R )  {
+  mmdb::shortrealUniBin srUB;
+    mmdb::shortreal2UniBin ( R,srUB );
+    write_buffer ( srUB,sizeof(mmdb::shortrealUniBin) );
+  }
 
-  rc = CMemIO::Ok;
+  void MemIO::put_line ( mmdb::cpstr L )  {
+    write_buffer ( L,strlen(L)+1 );  // null-terminated
+  }
 
-  if ((compression_level==Z_NO_COMPRESSION) || (buffer_length<=0))  {
+  void MemIO::put_string ( mmdb::cpstr S )  {
+  int len;
+    if (S)  len = strlen ( S );
+      else  len = 0;
+    put_integer ( len );
+    if (len>0)
+      write_buffer ( S,len );  // not null-terminated
+  }
 
-    if (f.WriteInt(&buffer_length))  {
-      if (!f.WriteFile(buffer,buffer_length))
-        rc = CMemIO::WriteError;
+  void MemIO::put_bool ( bool B )  {
+  char c;
+    if (B)  c = 'Y';
+      else  c = 'N';
+    write_buffer ( &c,1 );
+  }
+
+
+  bool MemIO::read_buffer ( void * dest, const int length,
+                                      bool * Ok )  {
+    if (buffer_pos+length<=buffer_length)  {
+      memcpy ( dest,&(buffer[buffer_pos]),length );
+      buffer_pos += length;
+      return true;
     }
+    if (Ok) *Ok = false;
+    return false;
+  }
 
-  } else  {
+  bool MemIO::get_integer ( int & I, bool * Ok )  {
+  mmdb::intUniBin iUB;
+    if (read_buffer(iUB,sizeof(mmdb::intUniBin),Ok))  {
+      mmdb::UniBin2int ( iUB,I );
+      return true;
+    } else  {
+      I = 0;
+      return false;
+    }
+  }
 
-    len = -buffer_length - 1;
-    if (f.WriteInt(&len))  {
+  bool MemIO::get_ishort ( int & I, bool * Ok )  {
+  mmdb::shortUniBin sUB;
+  short             Ishort;
+    if (read_buffer(sUB,sizeof(mmdb::shortUniBin),Ok))  {
+      mmdb::UniBin2short ( sUB,Ishort );
+      I = Ishort;
+      return true;
+    } else  {
+      I = 0;
+      return false;
+    }
+  }
 
-      csize = (uLongf)(1.1*buffer_length);
-      if (compression_alloc<=int(csize))  {
-        FreeVectorMemory ( compression_buffer,0 );
-        GetVectorMemory  ( compression_buffer,csize,0 );
-      }
+  bool MemIO::get_ibyte ( int & I, bool * Ok )  {
+  mmdb::byte B;
+    if (read_buffer(&B,sizeof(mmdb::byte),Ok))  {
+      I = B;
+      return true;
+    } else  {
+      I = 0;
+      return false;
+    }
+  }
 
-      rc = compress2 ( compression_buffer,&csize,
-                       buffer,buffer_length,compression_level );
+  bool MemIO::get_byte ( mmdb::byte & B, bool * Ok )  {
+    return read_buffer ( &B,sizeof(mmdb::byte),Ok );
+  }
 
-      if (rc==Z_OK)  {
-        len = csize;
-        if (f.WriteInt(&len))  {
-          if (!f.WriteFile(compression_buffer,csize))
-                rc = CMemIO::WriteError;
-          else  rc = CMemIO::Ok;
-        } else
-          rc = CMemIO::WriteError;
-      } else
-        rc = CMemIO::CompressionError;
+  bool MemIO::get_short ( short & I, bool * Ok )  {
+  mmdb::shortUniBin sUB;
+    if (read_buffer(sUB,sizeof(mmdb::shortUniBin),Ok))  {
+      mmdb::UniBin2short ( sUB,I );
+      return true;
+    } else  {
+      I = 0;
+      return false;
+    }
+  }
 
-    } else
-      rc = CMemIO::WriteError;
+  bool MemIO::get_long ( long & I, bool * Ok )  {
+  mmdb::longUniBin lUB;
+    if (read_buffer(lUB,sizeof(mmdb::longUniBin),Ok))  {
+      mmdb::UniBin2long ( lUB,I );
+      return true;
+    } else  {
+      I = 0;
+      return false;
+    }
+  }
+
+  bool MemIO::get_word ( mmdb::word & W, bool * Ok )  {
+  mmdb::wordUniBin wUB;
+    if (read_buffer(wUB,sizeof(mmdb::wordUniBin),Ok))  {
+      mmdb::UniBin2word ( wUB,W );
+      return true;
+    } else  {
+      W = 0;
+      return false;
+    }
+  }
+
+  bool MemIO::get_real ( mmdb::realtype & R, bool * Ok )  {
+  mmdb::realUniBin rUB;
+    if (read_buffer(rUB,sizeof(mmdb::realUniBin),Ok))  {
+      mmdb::UniBin2real ( rUB,R );
+      return true;
+    } else  {
+      R = 0.0;
+      return false;
+    }
+  }
+
+  bool MemIO::get_float ( mmdb::realtype & R, bool * Ok )  {
+  mmdb::floatUniBin fUB;
+    if (read_buffer(fUB,sizeof(mmdb::floatUniBin),Ok))  {
+      mmdb::UniBin2float ( fUB,R );
+      return true;
+    } else  {
+      R = 0.0;
+      return false;
+    }
+  }
 
+  bool MemIO::get_shortreal ( mmdb::shortreal & R, bool * Ok )  {
+  mmdb::shortrealUniBin srUB;
+    if (read_buffer(srUB,sizeof(mmdb::shortrealUniBin),Ok))  {
+      mmdb::UniBin2shortreal ( srUB,R );
+      return true;
+    } else  {
+      R = 0.0;
+      return false;
+    }
   }
 
-  return rc;
+  bool MemIO::get_line ( mmdb::pstr L, bool * Ok )  {
+  int  i;
+  char c;
+    i = 0;
+    c = ' ';
+    while (c && (buffer_pos<buffer_length))  {
+      c      = buffer[buffer_pos++];
+      L[i++] = c;
+    }
+    if (!c)
+      return true;
+    else  {
+      if (Ok)  Ok = false;
+      return false;
+    }
+  }
 
-}
+  bool MemIO::get_string ( mmdb::pstr & L, bool * Ok )  {
+  int len;
+    if (L)  delete[] L;
+    L = NULL;
+    if (get_integer(len,Ok))  {
+      if (len>0)  {
+        L = new char[len+1];
+        L[len] = char(0);
+        return read_buffer ( L,len,Ok );
+      }
+      return true;
+    }
+    return false;
+  }
 
-void CMemIO::reset()  {
-  buffer_length = 0;
-}
-
-void CMemIO::free()  {
-  FreeVectorMemory ( compression_buffer,0 );
-  FreeVectorMemory ( buffer            ,0 );
-  compression_alloc = 0;
-  buffer_length     = 0;
-  buffer_pos        = 0;
-  alloc_length      = 0;
-}
-
-void *CMemIO::get_buffer ( const int length )  {
-  if (alloc_length<length)  {
-    FreeVectorMemory ( buffer,0 );
-    alloc_length = length;
-    GetVectorMemory ( buffer,alloc_length,0 );
-  }
-  return buffer;
-}
-
-void CMemIO::get_buffer ( pstr * buf, int * length )  {
-  *buf    = pstr(buffer);
-  *length = buffer_length;
-}
-
-
-void CMemIO::write_buffer ( const void * src, const int length  )  {
-bvector b1;
-  if (buffer_length+length>=alloc_length)  {
-    alloc_length += length+chunk_size;
-    GetVectorMemory ( b1,alloc_length,0 );
-    memcpy ( b1,buffer,buffer_length );
-    FreeVectorMemory ( buffer,0 );
-    buffer = b1;
-  }
-  memcpy ( &(buffer[buffer_length]),src,length );
-  buffer_length += length;
-}
-
-
-void CMemIO::put_integer ( int I )  {
-intUniBin iUB;
-  int2UniBin ( I,iUB );
-  write_buffer ( iUB,sizeof(intUniBin) );
-}
-
-void CMemIO::put_ishort ( int I )  {
-shortUniBin sUB;
-  short2UniBin ( short(I),sUB );
-  write_buffer ( sUB,sizeof(shortUniBin) );
-}
-
-void CMemIO::put_ibyte ( int I )  {
-// here we do not rely only on little-endian architectures
-byte B;
-  B = byte(I);
-  write_buffer ( &B,sizeof(byte) );
-}
-
-void CMemIO::put_byte ( byte B )  {
-  write_buffer ( &B,sizeof(byte) );
-}
-
-void CMemIO::put_short ( short I )  {
-shortUniBin sUB;
-  short2UniBin ( I,sUB );
-  write_buffer ( sUB,sizeof(shortUniBin) );
-}
-
-void CMemIO::put_long ( long I )  {
-longUniBin lUB;
-  long2UniBin ( I,lUB );
-  write_buffer ( lUB,sizeof(longUniBin) );
-}
-
-void CMemIO::put_word ( word W )  {
-wordUniBin wUB;
-  word2UniBin ( W,wUB );
-  write_buffer ( wUB,sizeof(wordUniBin) );
-}
-
-void CMemIO::put_real ( realtype R )  {
-realUniBin rUB;
-  real2UniBin ( R,rUB );
-  write_buffer ( rUB,sizeof(realUniBin) );
-}
-
-void CMemIO::put_float ( realtype R )  {
-floatUniBin fUB;
-  float2UniBin ( R,fUB );
-  write_buffer ( fUB,sizeof(floatUniBin) );
-}
-
-void CMemIO::put_shortreal ( shortreal R )  {
-shortrealUniBin srUB;
-  shortreal2UniBin ( R,srUB );
-  write_buffer ( srUB,sizeof(shortrealUniBin) );
-}
-
-void CMemIO::put_line ( cpstr L )  {
-  write_buffer ( L,strlen(L)+1 );  // null-terminated
-}
-
-void CMemIO::put_string ( cpstr S )  {
-int len;
-  if (S)  len = strlen ( S );
-    else  len = 0;
-  put_integer ( len );
-  if (len>0)
-    write_buffer ( S,len );  // not null-terminated
-}
-
-void CMemIO::put_boolean ( Boolean  B )  {
-char c;
-  if (B)  c = 'Y';
-    else  c = 'N';
-  write_buffer ( &c,1 );
-}
-
-
-Boolean CMemIO::read_buffer ( void * dest, const int length,
-                                    Boolean * Ok )  {
-  if (buffer_pos+length<=buffer_length)  {
-    memcpy ( dest,&(buffer[buffer_pos]),length );
-    buffer_pos += length;
-    return True;
-  }
-  if (Ok) *Ok = False;
-  return False;
-}
-
-Boolean CMemIO::get_integer ( int & I, Boolean * Ok )  {
-intUniBin iUB;
-  if (read_buffer(iUB,sizeof(intUniBin),Ok))  {
-    UniBin2int ( iUB,I );
-    return True;
-  } else  {
-    I = 0;
-    return False;
-  }
-}
-
-Boolean CMemIO::get_ishort ( int & I, Boolean * Ok )  {
-shortUniBin sUB;
-short       Ishort;
-  if (read_buffer(sUB,sizeof(shortUniBin),Ok))  {
-    UniBin2short ( sUB,Ishort );
-    I = Ishort;
-    return True;
-  } else  {
-    I = 0;
-    return False;
-  }
-}
-
-Boolean CMemIO::get_ibyte ( int & I, Boolean * Ok )  {
-byte B;
-  if (read_buffer(&B,sizeof(byte),Ok))  {
-    I = B;
-    return True;
-  } else  {
-    I = 0;
-    return False;
-  }
-}
-
-Boolean CMemIO::get_byte ( byte & B, Boolean * Ok )  {
-  return read_buffer ( &B,sizeof(byte),Ok );
-}
-
-Boolean CMemIO::get_short ( short & I, Boolean * Ok )  {
-shortUniBin sUB;
-  if (read_buffer(sUB,sizeof(shortUniBin),Ok))  {
-    UniBin2short ( sUB,I );
-    return True;
-  } else  {
-    I = 0;
-    return False;
-  }
-}
-
-Boolean CMemIO::get_long ( long & I, Boolean * Ok )  {
-longUniBin lUB;
-  if (read_buffer(lUB,sizeof(longUniBin),Ok))  {
-    UniBin2long ( lUB,I );
-    return True;
-  } else  {
-    I = 0;
-    return False;
-  }
-}
-
-Boolean CMemIO::get_word ( word & W, Boolean * Ok )  {
-wordUniBin wUB;
-  if (read_buffer(wUB,sizeof(wordUniBin),Ok))  {
-    UniBin2word ( wUB,W );
-    return True;
-  } else  {
-    W = 0;
-    return False;
-  }
-}
-
-Boolean CMemIO::get_real ( realtype & R, Boolean * Ok )  {
-realUniBin rUB;
-  if (read_buffer(rUB,sizeof(realUniBin),Ok))  {
-    UniBin2real ( rUB,R );
-    return True;
-  } else  {
-    R = 0.0;
-    return False;
-  }
-}
-
-Boolean CMemIO::get_float ( realtype & R, Boolean * Ok )  {
-floatUniBin fUB;
-  if (read_buffer(fUB,sizeof(floatUniBin),Ok))  {
-    UniBin2float ( fUB,R );
-    return True;
-  } else  {
-    R = 0.0;
-    return False;
-  }
-}
-
-Boolean CMemIO::get_shortreal ( shortreal & R, Boolean * Ok )  {
-shortrealUniBin srUB;
-  if (read_buffer(srUB,sizeof(shortrealUniBin),Ok))  {
-    UniBin2shortreal ( srUB,R );
-    return True;
-  } else  {
-    R = 0.0;
-    return False;
-  }
-}
-
-Boolean CMemIO::get_line ( pstr L, Boolean * Ok )  {
-int  i;
-char c;
-  i = 0;
-  c = ' ';
-  while (c && (buffer_pos<buffer_length))  {
-    c      = buffer[buffer_pos++];
-    L[i++] = c;
-  }
-  if (!c)
-    return True;
-  else  {
-    if (Ok)  Ok = False;
-    return False;
-  }
-}
-
-Boolean CMemIO::get_string ( pstr & L, Boolean * Ok )  {
-int len;
-  if (L)  delete[] L;
-  L = NULL;
-  if (get_integer(len,Ok))  {
-    if (len>0)  {
-      L = new char[len+1];
-      L[len] = char(0);
-      return read_buffer ( L,len,Ok );
-    }
-    return True;
-  }
-  return False;
-}
-
-Boolean CMemIO::get_boolean ( Boolean  & B, Boolean * Ok )  {
-char c;
-  if (read_buffer(&c,1,Ok))  {
-    B = (c=='Y');
-    return True;
+  bool MemIO::get_bool ( bool & B, bool * Ok )  {
+  char c;
+    if (read_buffer(&c,1,Ok))  {
+      B = (c=='Y');
+      return true;
+    }
+    return false;
   }
-  return False;
-}
 
+}  // namespace ccp4srs
diff -ruN ccp4srs-old/ccp4srs/memio_.h ccp4srs/ccp4srs/memio_.h
--- ccp4srs-old/ccp4srs/memio_.h	2014-03-24 10:40:19.000000000 -0700
+++ ccp4srs/ccp4srs/memio_.h	2014-09-09 21:34:12.000000000 -0700
@@ -1,10 +1,10 @@
-//  $Id: memio_.h, v 1.00 2010/03/11 15:28:14 Eugene Exp $
+//  $Id: memio_.h $
 //  =================================================================
 //
 //   CCP4 SRS Library: Storage, Retrievak and Search support for
 //   CCP4 ligand data.
 //
-//   Copyright (C) Eugene Krissinel 2010.
+//   Copyright (C) Eugene Krissinel 2010-2013.
 //
 //   This library is free software: you can redistribute it and/or
 //   modify it under the terms of the GNU Lesser General Public
@@ -22,16 +22,16 @@
 //
 //  =================================================================
 //
-//    11.03.10   <--  Date of Last Modification.
+//    03.02.14   <--  Date of Last Modification.
 //                   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 //  -----------------------------------------------------------------
 //
 //  **** Module  :  memio_  <interface>
 //       ~~~~~~~~~
-//  **** Classes :  CMemIO  - buffered I/O
+//  **** Classes :  ccp4srs::MemIO  - buffered I/O
 //       ~~~~~~~~~
 //
-//  (C) E. Krissinel 2010
+//  (C) E. Krissinel 2010-2014
 //
 //  =================================================================
 //
@@ -39,75 +39,81 @@
 #ifndef MEMIO_H
 #define MEMIO_H
 
-#include "mmdb/file_.h"
+#include "mmdb2/mmdb_io_file.h"
 
-DefineClass(CMemIO)
+namespace ccp4srs  {
 
-class CMemIO  {
+  DefineClass(MemIO);
 
-  public:
+  class MemIO  {
 
-    enum { Ok,CantOpenFile,EmptyFile,ReadError,WriteError,MemReadError,
-           CompressionError,UncompressionError,SizeError };
-
-    CMemIO();
-    virtual ~CMemIO();
-
-    void  setCompressionLevel ( int compressionLevel ); // 0,1,2,3
-
-    int   read  ( cpstr  fileName, byte gzMode=GZM_NONE );
-    int   read  ( RCFile f );
-
-    int   write ( cpstr  fileName, byte gzMode=GZM_NONE );
-    int   write ( RCFile f );
-
-    int   length() { return buffer_length; }
-
-    void  reset();
-    void  free ();
-
-    void * get_buffer ( const int length );
-    void   set_buffer_length ( const int len )  { buffer_length = len; }
-    void   get_buffer ( pstr * buf, int * length );
-
-    void    write_buffer ( const void * src,  const int length  );
-    Boolean read_buffer  ( void       * dest, const int length,
-                           Boolean * Ok = NULL);
-
-    void  put_integer   ( int       I );
-    void  put_ishort    ( int       I );  // saves as short
-    void  put_ibyte     ( int       I );  // saves as byte
-    void  put_byte      ( byte      B );
-    void  put_short     ( short     I );
-    void  put_long      ( long      I );
-    void  put_word      ( word      W );
-    void  put_real      ( realtype  R );
-    void  put_float     ( realtype  R );  // stores single precision
-    void  put_shortreal ( shortreal R );
-    void  put_line      ( cpstr     L );  // for static strings
-    void  put_string    ( cpstr     L );  // for dynamic strings
-    void  put_boolean   ( Boolean   B );
-
-    Boolean  get_integer   ( int       & I, Boolean * Ok = NULL );
-    Boolean  get_ishort    ( int       & I, Boolean * Ok = NULL );
-    Boolean  get_ibyte     ( int       & I, Boolean * Ok = NULL );
-    Boolean  get_byte      ( byte      & B, Boolean * Ok = NULL );
-    Boolean  get_short     ( short     & I, Boolean * Ok = NULL );
-    Boolean  get_long      ( long      & I, Boolean * Ok = NULL );
-    Boolean  get_word      ( word      & W, Boolean * Ok = NULL );
-    Boolean  get_real      ( realtype  & R, Boolean * Ok = NULL );
-    Boolean  get_float     ( realtype  & R, Boolean * Ok = NULL );
-    Boolean  get_shortreal ( shortreal & R, Boolean * Ok = NULL );
-    Boolean  get_line      ( pstr        L, Boolean * Ok = NULL );
-    Boolean  get_string    ( pstr      & L, Boolean * Ok = NULL );
-    Boolean  get_boolean   ( Boolean   & B, Boolean * Ok = NULL );
-
-  private:
-    int     compression_level;
-    bvector buffer,compression_buffer;
-    int     buffer_length,buffer_pos,alloc_length,chunk_size;
-    int     compression_alloc;
+    public:
+
+      enum { Ok,CantOpenFile,EmptyFile,ReadError,WriteError,MemReadError,
+             CompressionError,UncompressionError,SizeError };
+
+      MemIO();
+      virtual ~MemIO();
+
+      void  setCompressionLevel ( int compressionLevel ); // 0,1,2,3
+
+      int   read  ( mmdb::cpstr  fileName,
+                    mmdb::io::GZ_MODE gzMode=mmdb::io::GZM_NONE );
+      int   read  ( mmdb::io::RFile f );
+
+      int   write ( mmdb::cpstr  fileName,
+                    mmdb::io::GZ_MODE gzMode=mmdb::io::GZM_NONE );
+      int   write ( mmdb::io::RFile f );
+
+      int   length() { return buffer_length; }
+
+      void  reset();
+      void  free ();
+
+      void * get_buffer        ( const int length );
+      void   set_buffer_length ( const int len )  { buffer_length = len; }
+      void   get_buffer        ( mmdb::pstr * buf, int * length );
+
+      void  write_buffer ( const void * src,  const int length  );
+      bool  read_buffer  ( void       * dest, const int length,
+                           bool * Ok = NULL);
+
+      void  put_integer   ( int        I );
+      void  put_ishort    ( int        I );  // saves as short
+      void  put_ibyte     ( int        I );  // saves as byte
+      void  put_byte      ( mmdb::byte B );
+      void  put_short     ( short      I );
+      void  put_long      ( long       I );
+      void  put_word      ( mmdb::word W );
+      void  put_real      ( mmdb::realtype  R );
+      void  put_float     ( mmdb::realtype  R );  // stores single precision
+      void  put_shortreal ( mmdb::shortreal R );
+      void  put_line      ( mmdb::cpstr     L );  // for static strings
+      void  put_string    ( mmdb::cpstr     L );  // for dynamic strings
+      void  put_bool      ( bool   B );
+
+      bool  get_integer   ( int        & I, bool * Ok = NULL );
+      bool  get_ishort    ( int        & I, bool * Ok = NULL );
+      bool  get_ibyte     ( int        & I, bool * Ok = NULL );
+      bool  get_byte      ( mmdb::byte & B, bool * Ok = NULL );
+      bool  get_short     ( short      & I, bool * Ok = NULL );
+      bool  get_long      ( long       & I, bool * Ok = NULL );
+      bool  get_word      ( mmdb::word      & W, bool * Ok = NULL );
+      bool  get_real      ( mmdb::realtype  & R, bool * Ok = NULL );
+      bool  get_float     ( mmdb::realtype  & R, bool * Ok = NULL );
+      bool  get_shortreal ( mmdb::shortreal & R, bool * Ok = NULL );
+      bool  get_line      ( mmdb::pstr        L, bool * Ok = NULL );
+      bool  get_string    ( mmdb::pstr      & L, bool * Ok = NULL );
+      bool  get_bool      ( bool   & B, bool * Ok = NULL );
+
+    private:
+      int           compression_level;
+      mmdb::bvector buffer,compression_buffer;
+      int           buffer_length,buffer_pos,alloc_length,chunk_size;
+      int           compression_alloc;
 
-};
+  };
+
+}  // namespace ccp4srs
 
 #endif // MEMIO_H
